#include <stdio.h>
#include <stdlib.h>

#include "test.h"

#define FNAME(n) my_ ## n
extern T FNAME(rule1)(T x, T y);
extern T FNAME(rule2)(T x, T y);
extern T FNAME(rule3)(T x, T y);
extern T FNAME(rule4)(T x, T y);
extern T FNAME(special1)(T x, T y);

#undef FNAME
#define FNAME(n) gcc_ ## n
extern T FNAME(rule1)(T x, T y);
extern T FNAME(rule2)(T x, T y);
extern T FNAME(rule3)(T x, T y);
extern T FNAME(rule4)(T x, T y);
extern T FNAME(special1)(T x, T y);

void error(unsigned i) {
    fprintf (stderr, "WTF %d\n", i);
    exit(1);
}

int
main (int argc, char** argv) {
    unsigned int i;
    for (i = 0; i < (unsigned)-1; i++) {
        #if 0
        if (gcc_rule1(i, 0) != my_rule1(i, 0)) error(i);
        if (gcc_rule2(i, 0) != my_rule2(i, 0)) error(i);
        if (gcc_rule3(i, 0) != my_rule3(i, 0)) error(i);
        if (gcc_rule4(i, 0) != my_rule4(i, 0)) error(i);
        #endif
        if (gcc_special1(i, 0) != my_special1(i, 0)) error(i);
    }

    return 0;
}
